﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Syncfusion.Olap.Manager;
using Syncfusion.Olap.Reports;
using Syncfusion.Olap.Data;

namespace WebApplication1
{
    public partial class OlapClient : System.Web.UI.Page
    {
        OlapDataManager DataManager1;
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                //Enter valid connection string
                DataManager1 = new OlapDataManager(@"Data Source = D:\Adventure_Works_Ext.Cub; Provider = MSOLAP;");
                DataManager1.SetCurrentReport(CreateOlapReport());
                this.OlapClient1.OlapDataManager = DataManager1;
                this.OlapClient1.DataBind();
            }
            TreeNodeCollection tree = this.OlapClient1.CubeDimensionBrowser.Nodes[0].ChildNodes;
            for (int i = tree.Count - 1; i >= 0; i--)
                if (tree[i].Text == "Customer" || tree[i].Text == "Employee")
                    this.OlapClient1.CubeDimensionBrowser.Nodes[0].ChildNodes.Remove(tree[i]);
            this.OlapClient1.CubeDimensionBrowser.TreeNodeExpanded += CubeDimensionBrowser_TreeNodeExpanded;
        }
        void CubeDimensionBrowser_TreeNodeExpanded(object sender, TreeNodeEventArgs e)
        {
                        TreeNodeCollection tree = e.Node.ChildNodes;
                        for (int i = tree.Count - 1; i >= 0; i--)
                        {
                            if (tree[i].Text == "Internet Sales Amount")
                                tree.RemoveAt(i);
                        }
        }
        private OlapReport CreateOlapReport()
        {
            OlapReport olapReport = new OlapReport();
            olapReport.CurrentCubeName = "Adventure Works";
            olapReport.Name = "Default Report";

            DimensionElement dimensionelement = new DimensionElement() { Name = "Product", HierarchyName = "Category" };
            dimensionelement.AddLevel("Category", "Category");
            olapReport.SeriesElements.Add(dimensionelement);

            MeasureElements measureElement = new MeasureElements();
            measureElement.Elements.Add(new MeasureElement { Name = "Internet Sales Amount" });
            olapReport.CategoricalElements.Add(measureElement);

            return olapReport;
        }
    }
}